
;(define (run-repl args envt)
;  (fluid-let ((*console-input-port*
;               (if *script*
;                   $console-input-port
;                   (open-edit-port)))
;              (*console-output-port* $console-output-port)
;              (*top-level-envt* envt))
;    (handler-bind (<condition> repl-condition-handler)
;                  (register-interrupt-handler! 'control-c repl-interrupt)
;                  (interpret-repl-args args envt))))

(define (startup-threads args)
  (run-threads
   (begin
     (format #t "Launching threaded repl...\n")
     (format #t "Disabling blocking on stdio streams...\n")
     (fd-set-blocking 0 #f)
     (fd-set-blocking 1 #f)
     (fd-set-blocking 2 #f)
     
     (format #t "Converting streams to <os-channels>.\n")
     (fluid-let ((*input-port* (input-port (fd->os-channel 0 'read)))
                 (*output-port* (output-port (fd->os-channel 1 'write)))
                 (*error-port* (output-port (fd->os-channel 2 'write))))
       (make <thread> 
             name: "repl-thread"
             thunk:
             (lambda ()
               (format *error-port* "Creating new repl for stdio.\n")
               (let ((edit (open-edit-port)))
                 (fluid-let ((*console-input-port* edit))
                   
                   (format #t "Launching repl, args: ~a\n" args)
                   ;;((exported-value repl main) args)))))))))
                   ;;(cmd-loop *self* "*top[~d]=> ")))))))))
                   
                   (handler-bind 
                    (<condition> repl-condition-handler)
                    (register-interrupt-handler! 'control-c repl-interrupt)
                    (interpret-repl-args args *self*))))))))))
